using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Pokespearean.Models;
using Pokespearean.Services;

namespace Pokespearean
{
	public class Startup
	{
		public Startup(IConfiguration configuration)
		{
			Configuration = configuration;
		}

		public IConfiguration Configuration { get; }

		public void ConfigureServices(IServiceCollection services)
		{
			services.AddScoped<IPokemonService, PokemonService>();
			services.AddScoped<IShakespeareService, ShakespeareService>();
			services.Configure<Settings>(Configuration.GetSection(nameof(Settings)));

			services.AddControllers().AddJsonOptions(options =>
			{
				options.JsonSerializerOptions.IgnoreReadOnlyFields = true;
				options.JsonSerializerOptions.IgnoreReadOnlyProperties = true;
			});
		}

		public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
		{
			if (env.IsDevelopment())
			{
				app.UseDeveloperExceptionPage();
			}

			app.UseRouting();
			app.UseEndpoints(endpoints =>
			{
				endpoints.MapControllers();
			});
		}
	}
}
